Index: www/xhp/ia/sidebar.php
new file mode 100644
===================================================================
--- www/xhp/ia/sidebar.php	(revision 0)
+++ www/xhp/ia/sidebar.php	(working copy)
@@ -0,0 +1,136 @@
+<?php
+// Contains XHP objects for the site's left side bar.
+
+require_once(IA_ROOT_DIR . 'www/xhp/ia/login_form.php');
+
+class :ia:left-col extends :x:element {
+    attribute
+        array user;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        foreach ($this->getChildren('ia:left-navbar') as $child) {
+            $child->setAttribute('user', $user);
+        }
+        return
+          <div id="sidebar">
+            {$this->getChildren()}
+          </div>;
+    }
+}
+
+class :ia:left-navbar extends :x:element {
+    attribute
+        array user;
+    children empty;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        $list =
+          <ul id="nav" class="clear">
+            <li><a href={url_home()}>Home</a></li>
+            <li>
+              <ui:link href={url_textblock('arhiva')} accesskey="a">
+                Arhiva de probleme
+              </ui:link>
+            </li>
+            <li>
+              <a href={url_textblock('arhiva-educationala')}>
+                Arhiva educatională
+              </a>
+            </li>
+            <li><a href={url_textblock('concursuri')}>Concursuri</a></li>
+            <li>
+              <a href={url_textblock('concursuri-virtuale')}>
+                Concursuri virtuale
+              </a>
+            </li>
+            <li><a href={url_textblock('clasament-rating')}>Clasament</a></li>
+            <li><a href={url_textblock('articole')}>Articole</a></li>
+            <li><a href={url_textblock('downloads')}>Downloads</a></li>
+            <li><a href={url_textblock('links')}>Links</a></li>
+            <li><a href={url_textblock('documentatie')}>Documentaţie</a></li>
+            <li>
+              <a href={url_textblock('despre-infoarena')}>Despre infoarena</a>
+            </li>
+            <li class="separator"><hr/></li>
+          </ul>;
+
+        if ($user) {
+            $list->appendChild(
+              <li>
+                <ui:link
+                  href={url_monitor(array('user' => $user['username']))}
+                  accesskey="m">
+                  Monitorul de evaluare
+                </ui:link>
+              </li>);
+            $list->appendChild(
+              <li>
+                <a href={url_submit()}>
+                  <strong>Trimite soluţii</strong>
+                </a>
+              </li>);
+            $list->appendChild(
+              <li>
+                <ui:link href={url_account()} accesskey="c">
+                  Contul meu
+                </ui:link>
+              </li>);
+        } else {
+            $list->appendChild(
+              <li>
+                <ui:link href={url_monitor()} accesskey="m">
+                  Monitorul de evaluare
+                </ui:link>
+              </li>);
+        }
+
+        return $list;
+    }
+}
+
+class :ia:sidebar-ad extends :x:element {
+    children empty;
+
+    protected function render() {
+        $sidebar = textblock_get_revision(IA_SIDEBAR_PAGE);
+        if (!$sidebar) {
+            return <x:frag />;
+        }
+
+        return
+          <div class="ad">
+            <div class="wiki_text_block">
+              {HTML(wiki_process_textblock($sidebar))}
+            </div>
+          </div>;
+    }
+}
+
+class :ia:sidebar-login extends :x:element {
+    attribute
+        bool show_login_form = true;
+    children empty;
+
+    protected function render() {
+        if ($this->getAttribute('show_login_form')) {
+            $form = <ia:login-form />;
+        } else {
+            $form = <x:frag />;
+        }
+
+        $extra =
+          <p>
+            <ui:link href={url_register()}>Mă înregistrez!</ui:link>
+            <br />
+            <ui:link href={url_resetpass()}>Mi-am uitat parola...</ui:link>
+          </p>;
+
+        return
+          <div id="login">
+            {$form}
+            {$extra}
+          </div>;
+    }
+}
Index: www/xhp/ia/sitewide.php
new file mode 100644
===================================================================
--- www/xhp/ia/sitewide.php	(revision 0)
+++ www/xhp/ia/sitewide.php	(working copy)
@@ -0,0 +1,191 @@
+<?php
+// Contains important XHP objects that are needed to render the website's
+// frame, such as the website header, footer and navigation bar.
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/link.php');
+
+class :ia:header:userbox extends :x:element {
+    attribute
+        array user      @required;
+    children empty;
+
+    protected function render() {
+        $user = $this->getAttribute('user');
+        $username = $user['username'];
+
+        return
+          <div id="userbox">
+            <ui:link href={url_user_profile($username, true)}>
+              {HTML(format_user_avatar($username, "normal", true))}
+            </ui:link>
+            <div class="user">
+              <strong>{$user['full_name']}</strong><br />
+              {HTML(format_user_ratingbadge($username, $user['rating_cache']))}&nbsp;<ui:link href={url_user_profile($username, true)} accesskey="p">{$username}</ui:link><br />
+              {HTML(format_post_link(url_logout(), "logout", array(), true, array('class' => 'logout')))} |
+              <ui:link href={url_account()} accesskey="c">contul meu</ui:link>
+            </div>
+          </div>;
+    }
+}
+
+class :ia:header extends :x:element {
+    attribute
+        array user;
+    children empty;
+
+    protected function render() {
+        $header = <div id="header" class="clear" />;
+
+        $user = $this->getAttribute('user');
+        if ($user) {
+            $header->appendChild(<ia:header:userbox user={$user} />);
+        }
+
+        if (IA_DEVELOPMENT_MODE) {
+            $header->appendChild(
+              <div id="dev_warning">
+                Bravely working in development mode&hellip;<br/>Keep it up!
+              </div>);
+        }
+
+        $header->appendChild(
+          <h1>
+            <ui:link href={url_home()}>
+              infoarena informatica de performanta
+            </ui:link>
+          </h1>);
+
+        return $header;
+    }
+}
+
+class :ia:top-navbar extends :x:element {
+    attribute
+        array user,
+        int user_pm_count = 0,
+        string selected = "infoarena";
+    children empty;
+
+    protected function render() {
+        $fields = array(
+          'infoarena' =>
+            <ui:link href={url_home()}>info<em>arena</em></ui:link>,
+          'blog' => <ui:link href={url_blog()} accesskey="b">blog</ui:link>,
+          'forum' => <ui:link href={url_forum()} accesskey="f">forum</ui:link>,
+          'calendar' =>
+            <ui:link href={url_forum() . '?action=calendar'}>
+              calendar
+            </ui:link>,
+        );
+
+        $user = $this->getAttribute('user');
+        if (!$user) {
+            $fields['login'] =
+              <ui:link href={url_login()}>autentificare</ui:link>;
+            $fields['register'] =
+              <ui:link href={url_login()}>inregistrare</ui:link>;
+        } else {
+            $fields['profile'] =
+              <ui:link href={url_user_profile($user['username'])}
+                accesskey="p">profilul meu</ui:link>;
+
+            $user_pm_count = $this->getAttribute('user_pm_count');
+            if ($user_pm_count) {
+                $pm_content = <strong>mesaje ({$user_pm_count})</strong>;
+            } else {
+                $pm_content = 'mesaje';
+            }
+            $fields['pm'] =
+              <ui:link href={url_forum() . '?action=pm'}>
+                {$pm_content}
+              </ui:link>;
+
+            if ($user['security_level'] === 'admin') {
+                $fields['smf_admin'] =
+                  <ui:link href={url_forum() . '?action=admin'}>
+                    forum admin
+                  </ui:link>;
+            }
+        }
+
+        $selected = $this->getAttribute('selected');
+        $list = <ul />;
+        foreach ($fields as $name => $content) {
+            if ($selected === $name) {
+                $content = <strong>{$content}</strong>;
+            }
+            $list->appendChild(<li>{$content}</li>);
+        }
+
+        return
+          <div id="topnav">
+            {$list}
+          </div>;
+    }
+}
+
+class :ia:footer extends :x:element {
+    children empty;
+
+    protected function render() {
+        $elem =
+          <div id="footer">
+            <ul class="clear">
+              <li class="copyright">&copy;&nbsp;2004-{date("Y")}&nbsp;<ui:link href={url_textblock('Asociatia-infoarena')}>Asociatia infoarena</ui:link></li>
+              <li class="separate">
+                <ui:link href={url_home()}>Prima pagina</ui:link>
+              </li>
+              <li>
+                <ui:link href={url_textblock('despre-infoarena')}>
+                  Despre infoarena
+                </ui:link>
+              </li>
+              <li>
+                <ui:link href={url_textblock('termeni-si-conditii')}>
+                  Termeni si conditii
+                </ui:link>
+              </li>
+              <li>
+                <ui:link href={url_textblock('contact')}>Contact</ui:link>
+              </li>
+              <li class="top">
+                <a href="#header">Sari la inceputul paginii &uarr;</a>
+              </li>
+            </ul>
+          </div>;
+
+        if (!IA_DEVELOPMENT_MODE) {
+            $elem->appendChild(
+            <p class="cc">
+              {HTML('<!--Creative Commons License-->')}
+              <a class="badge" rel="license" href="http://creativecommons.org/licenses/by-nc/2.5/"><img alt="Creative Commons License" src={url_static('images/CreativeCommonsBadge.png')} /></a>
+              Cu exceptia cazurilor in care se specifica altfel, continutul site-ului infoarena<br/>este publicat sub licenta <a rel="license" href="http://creativecommons.org/licenses/by-nc/2.5/">Creative Commons Attribution-NonCommercial 2.5</a>.
+              {HTML('<!--/Creative Commons License-->
+                <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">
+                  <Work rdf:about="">
+                    <license rdf:resource="http://creativecommons.org/licenses/by-nc/2.5/" />
+                  </Work>
+                  <License rdf:about="http://creativecommons.org/licenses/by-nc/2.5/">
+                    <permits rdf:resource="http://web.resource.org/cc/Reproduction"/>
+                    <permits rdf:resource="http://web.resource.org/cc/Distribution"/>
+                    <requires rdf:resource="http://web.resource.org/cc/Notice"/>
+                    <requires rdf:resource="http://web.resource.org/cc/Attribution"/>
+                    <prohibits rdf:resource="http://web.resource.org/cc/CommercialUse"/>
+                    <permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/>
+                  </License>
+                </rdf:RDF>')}
+            </p>);
+
+            $elem->appendChild(
+              <script src="http://www.google-analytics.com/urchin.js" type="text/javascript" />);
+            $elem->appendChild(
+              <script type="text/javascript">
+                _uacct = 'UA-113289-8';
+                _udn = 'infoarena.ro';
+                urchinTracker();
+              </script>);
+        }
+
+        return $elem;
+    }
+}
Index: www/xhp/ia/user_count.php
new file mode 100644
===================================================================
--- www/xhp/ia/user_count.php	(revision 0)
+++ www/xhp/ia/user_count.php	(working copy)
@@ -0,0 +1,12 @@
+<?php
+
+class :ia:user-count extends :x:element {
+    children empty;
+
+    protected function render() {
+        return
+          <p class="user-count">
+            {user_count()} membri înregistraţi
+          </p>;
+    }
+}
Index: www/xhp/ui/base.php
new file mode 100644
===================================================================
--- www/xhp/ui/base.php	(revision 0)
+++ www/xhp/ui/base.php	(working copy)
@@ -0,0 +1,6 @@
+<?php
+
+class :ui:element extends :x:element {
+    // TODO: facebook was doing cool stuff with CSS margin and padding in ui
+    // elements
+}
Index: www/xhp/ui/breadcrumbs.php
new file mode 100644
===================================================================
--- www/xhp/ui/breadcrumbs.php	(revision 0)
+++ www/xhp/ui/breadcrumbs.php	(working copy)
@@ -0,0 +1,42 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:breadcrumbs extends :ui:element {
+    attribute
+        array entries,
+        string current,
+        string title = "Pagini recente";
+    children empty;
+
+    protected function render() {
+        $entries = $this->getAttribute('entries');
+        $current = $this->getAttribute('current');
+
+        if (count($entries) <= 1) {
+            return <x:frag />;
+        }
+
+        $elem =
+          <div class="breadcrumbs">
+            {$this->getAttribute('title')} &raquo;
+          </div>;
+        $first = true;
+        foreach ($entries as $key => $entry) {
+            list($url, $title) = $entry;
+
+            if (!$first) {
+                $elem->appendChild(<span class="separator"> | </span>);
+            } else {
+                $first = false;
+            }
+
+            if ($current == $key) {
+                $elem->appendChild(<strong>{$title}</strong>);
+            } else {
+                $elem->appendChild(<a href={$url}>{$title}</a>);
+            }
+        }
+        return $elem;
+    }
+}
Index: www/xhp/ui/flash_message.php
new file mode 100644
===================================================================
--- www/xhp/ui/flash_message.php	(revision 0)
+++ www/xhp/ui/flash_message.php	(working copy)
@@ -0,0 +1,15 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:flash-message extends :ui:element {
+    attribute
+        string class;
+
+    protected function render() {
+        return
+          <div class={'flash ' . $this->getAttribute('class')}>
+            {$this->getChildren()}
+          </div>;
+    }
+}
Index: www/xhp/ui/link.php
new file mode 100644
===================================================================
--- www/xhp/ui/link.php	(revision 0)
+++ www/xhp/ui/link.php	(working copy)
@@ -0,0 +1,27 @@
+<?php
+
+require_once(IA_ROOT_DIR . 'www/xhp/ui/base.php');
+
+class :ui:link extends :ui:element {
+    attribute
+        bool highlight_accesskey = true,    // Whether or not to highlight the
+                                            // link's accesskey if specified.
+        :a;
+
+    protected function render() {
+        $elem = <a>{$this->getChildren()}</a>;
+
+        $accesskey = $this->getAttribute('accesskey');
+        if ($accesskey && $this->getAttribute('highlight_accesskey')) {
+            // This assumes that no HTML tags are present inside the link.
+            // If these are present, they will be escaped.
+            $content = (string)<x:frag>{$this->getChildren()}</x:frag>;
+            $elem = <a>{format_highlight_access_key($content, $accesskey)}</a>;
+        }
+
+        foreach ($this->getAttributes() as $key => $value) {
+            $elem->setAttribute($key, $value);
+        }
+        return $elem;
+    }
+}
